package config

import (
	"os"
	"path/filepath"
)

func findLibrary() {
	dir := WorkingDirectory

	for {
		Library = filepath.Join(dir, "lib")
		stat, err := os.Stat(Library)

		if !os.IsNotExist(err) && stat != nil && stat.IsDir() {
			return
		}

		if dir == "/" {
			panic("standard library not found")
		}

		dir = filepath.Dir(dir)
	}
}
